﻿jQuery(document).ready(function($){ // allows compatibility with prototype and other libraries

	/* [-Stash-] 2010-02-19 11:29:10
	 * Hide the native Vanilla 1 comment box resizer since it doesn't work with CKEditor 3
	 */
	$('#CommentBoxController').hide();

	/* http://docs.cksource.com/CKEditor_3.x/Developers_Guide/Toolbar */
	var config = {
		extraPlugins:	'uicolor',
		uiColor:	'#eaeaea',
	};

	// Initialize the editor.
	// Callback function can be passed and executed after full instance creation.
	$('#CommentBox').ckeditor(config);

	/* [-Stash-] 2010-03-24 11:23:28
	 * Trying to make the editor appear only when the HTML radio button is checked...
	 * If you have any bright ideas on how to make this work, please share :)
	 */
	// if $('#Radio_Html').is(":checked")
		// $('#CommentBox').ckeditor(config);
		// else
		// $('#CommentBox').ckeditorGet().destroy();


	/* [-Stash-] 2010-02-19 11:50:30
	 * Stop CKEditor from butchering the sourcecode with random carriage returns.
	 * http://cksource.com/forums/viewtopic.php?f=6&t=14493&p=38352&hilit=ckeditor#p38352
	 * 
	 * [-Stash-] 2010-03-23 15:19:52
	 * Added in code and pre
	 */
	CKEDITOR.on('instanceReady', function(ev)
	{	var TagsBlock = ['br','caption','code','div','h1','h2','h3','h4','h5','h6','li','ol','p','pre','ul','table','tbody','td','th','thead','tr']; // etc.

		for (var key in TagsBlock) {
		ev.editor.dataProcessor.writer.setRules(TagsBlock[key],
			{	indent : true,
				breakBeforeOpen : true,
				breakAfterOpen : false,
				breakBeforeClose : false,
				breakAfterClose : true
			});
		}

		/* [-Stash-] 2010-02-24 17:10:34
		 * Slightly over the top since this is the same as default, but hey :D
		 */
		var TagsInline = ['a','span']; // etc.

		for (var key in TagsInline) {
		ev.editor.dataProcessor.writer.setRules(TagsInline[key],
			{	indent : false,
				breakBeforeOpen : false,
				breakAfterOpen : false,
				breakBeforeClose : false,
				breakAfterClose : false
			});
		}
	});

	/* [-Stash-] 2010-02-19 11:51:53
	 * Enable the MediaEmbed plugin for CKEditor 3
	 * http://www.fluidbyte.net/index.php?view=embed-youtube-vimeo-etc-into-ckeditor
	 * http://jesox.com/posts/how-add-youtube-vimeo-or-any-other-embed-content-ckeditor
	 */
	//config.extraPlugins = 'MediaEmbed';
	//CKEDITOR.plugins.addExternal('mediaembed','extensions/JQuery/plugins/ckeditor/plugins/mediaembed/');
	

	// http://docs.cksource.com/ckeditor_api/symbols/CKEDITOR.config.html
	config.entities = false;
	config.entities_latin = false;
	config.entities_greek = false;
	config.entities_processNumerical = false;
	config.disableNativeSpellChecker = false; // I quite like the Firefox spell checker...
	
	// http://docs.cksource.com/ckeditor_api/symbols/CKEDITOR.config.html#.baseHref
	config.baseHref = '';

	/* [-Stash-] 2010-03-23 15:19:04
	 * Little bit better, but if you have any better suggestions please make them.
	 */
	config.toolbar = 'VanillaMin';

	config.toolbar_VanillaMin =
	[
		['Format'],
		['Bold','Italic','Strike'],
		['NumberedList','BulletedList'],
		['Image','Smiley'],
		['Link','Unlink'],
		['RemoveFormat'],
		['Source','Maximize']
	];

	config.toolbar_VanillaFull =
	[
		['Maximize','Source','-','NewPage','Preview','-','Templates'],
		['Cut','Copy','Paste','PasteText','PasteFromWord','-','Print','SpellChecker','Scayt'],
		['Undo','Redo','-','Find','Replace','-','SelectAll','RemoveFormat'],
		/* ['Form', 'Checkbox', 'Radio', 'TextField', 'Textarea', 'Select', 'Button', 'ImageButton', 'HiddenField'], */
		'/',
		['Bold','Italic','Underline','Strike','-','Subscript','Superscript'],
		['NumberedList','BulletedList','-','Outdent','Indent','Blockquote'],
		['JustifyLeft','JustifyCenter','JustifyRight','JustifyBlock'],
		['Link','Unlink','Anchor'],
		['Image','Flash','Table','HorizontalRule','Smiley','SpecialChar'/* ,'PageBreak' */],
		'/',
		['Styles','Format'/* ,'Font' */,'FontSize'],
		['TextColor','BGColor'],
		[/* 'Maximize', */'ShowBlocks'/* ,'-','About' */]
	];

}); // allows compatibility with prototype and other libraries